/* Copyright (C) 1988-1998 Takafumi Sakurai
 * Permission to use, copy, modify, and distribute this file for any
 * purpose is hereby granted without fee, provided that both the above
 * copyright notice and this permission appear in all copies.
*/

/* kanji type */
#define	ascii_only	0
#define	jis_1		1	/* The third byte for enter kanji is at sign
				   and that for exit kanji is J */
#define	jis_2		2	/* at sign and H */
#define	jis_3		3	/* at sign and B */
#define	jis_4		4	/* B and J */
#define	jis_5		5	/* B and H */
#define	jis_6		6	/* B and B */
#define	shift_jis	10	/* shift jis code */
#define	jis7_1		11	/* jis_1 with 8bit through */
#define	jis7_2		12	/* jis_2 with 8bit through */
#define	jis7_3		13	/* jis_3 with 8bit through */
#define	jis7_4		14	/* jis_4 with 8bit through */
#define	jis7_5		15	/* jis_5 with 8bit through */
#define	jis7_6		16	/* jis_6 with 8bit through */
#define	EUC		20	/* Extended Unix Code,
				   eighth bit is on for both bytes */
/* kanji state */
/* input */
#define	KAN_ASCII	0
#define	KAN_JIS_FIRST	1
#define	KAN_JIS_SECOND	2
#define	KAN_ASCII_KAN	3
/* output */
#define	KAN_FIRST	1
#define	KAN_SECOND	2
#define	KAN_EIGHT	3

#define	ESC		'\033'
/*
#define	KANJIBIT	0x80
#define	isTeXkanji(c)	((c)&KANJIBIT)
#define	makeTeXkanji(c)	((c)|KANJIBIT)
#define	deTeXkanji(c)	((c)&~KANJIBIT)
*/

#define	EXTCHARBIT		0x80
#define	is_ext_char(c)		((c)&EXTCHARBIT)
#define	is_ext_eightbit(c)	((c)==EXTCHARBIT)
#define	ext_eightbit		EXTCHARBIT
#define	is_eightbit(c)		((c)&0x80)
#define	make_eightbit(c)	((c)|0x80)
#define	de_eightbit(c)		((c)&0x7f)
#define	is_ext_kanji(c)		((c)>EXTCHARBIT)
#define	make_ext_kanji(c)	((c)|EXTCHARBIT)
#define	de_ext_kanji(c)		((c)&~EXTCHARBIT)

typedef	unsigned char textchar;

typedef struct {
    char ktype, kstat;
    textchar kpend;
    int (*in_ln)();
    int (*out_ch)();
} kaninfo;

extern int hasargcode;
extern int hasargterm;
extern kaninfo kanjiinfo[];

int in_ln_ascii();
int in_ln_jis();
int in_ln_jis7();
int in_ln_sjis();

int out_ch_ascii();
int out_ch_jis();
int out_ch_sjis();
int out_ch_euc();

int check_eightbit();
int check_euc_kanji();
int check_sj_kanji();
int euc2TeXkanji();
int sj2TeXkanji();
int error_makekanji();
