/* Hand-coded routines for JBibTeX in C.  */

#define	EXTERN extern
#define NO_BIBTEX_HELP
#include "bibd.h"

char kanji_file_code, kanji_term_code;

#define	legal_kanji_code(kcode) \
	((jis_1 <= kcode && kcode <= jis_6) || \
	 kcode == shift_jis || kcode == EUC)

void
initkanji(void)
{
    char *p;

    kanji_file_code = DEFAULT_FILE_CODE;
    kanji_term_code = DEFAULT_TERM_CODE;

    if ((p = getenv("BIBFILECODE")) != NULL)
	kanji_file_code = atoi(p);
    if (!legal_kanji_code(kanji_file_code)) {
	fprintf(stderr,
		"Kanji File Code:%d is illegal. I'll use system default\n",
		kanji_file_code);
	kanji_file_code = DEFAULT_FILE_CODE;
    }
    if ((p=getenv("BIBTERMCODE")) != NULL)
	kanji_term_code = atoi(p);
    if (!legal_kanji_code(kanji_term_code)) {
	fprintf(stderr,
		"Kanji Term Code:%d is illegal. I'll use system default\n",
		kanji_term_code);
	kanji_term_code = DEFAULT_TERM_CODE;
    }

    setinkanjitype(stdin, kanji_term_code);
    setoutkanjitype(stdout, kanji_term_code);
}

void
input_line_bib(FILE *f, int *lc)
{
    register int i;
    register mlcinfo *mi = &mlcodeinfo[fileno(f)];

    i = (*(mi->in_ln))(f, mi);

    *lc = i;
}

boolean
a_open_in(FILE **f_ptr,  kpse_file_format_type filefmt,
              const_string fopen_mode)
{
    if (open_input(f_ptr, filefmt, fopen_mode)) {
	setinkanjitype(*f_ptr, kanji_file_code);
	return true;
    } else
	return false;
}

boolean
a_open_out(FILE **f_ptr,  const_string fopen_mode)
{
    if (open_output(f_ptr, fopen_mode)) {
	setoutkanjitype(*f_ptr, kanji_file_code);
	return true;
    } else
	return false;
}
