/* pdflua.c

   Copyright 2010 Taco Hoekwater <taco@luatex.org>
   Copyright 2010 Hartmut Henkel <hartmut@luatex.org>

   This file is part of LuaTeX.

   LuaTeX is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   LuaTeX is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
   License for more details.

   You should have received a copy of the GNU General Public License along
   with LuaTeX; if not, see <http://www.gnu.org/licenses/>. */

#include "ptexlib.h"

static const Byte compr[259] = {
    0x78, 0x9c, 0xad, 0x51, 0x4d, 0x4b, 0xc4, 0x30, 0x10, 0xbd, 0xe7, 0x57, 0xcc, 0xa1, 0x07, 0x85,
    0xcd, 0x47, 0x57, 0x71, 0x69, 0xc1, 0x1f, 0x20, 0x78, 0x12, 0xbc, 0x78, 0x4b, 0xdb, 0x69, 0x1b,
    0x1a, 0x92, 0x30, 0x49, 0x5c, 0x17, 0xf1, 0xbf, 0x9b, 0x42, 0xd1, 0x55, 0xf1, 0xb6, 0x61, 0x12,
    0x1e, 0xf3, 0x5e, 0xe6, 0x3d, 0x18, 0xce, 0xa1, 0x7a, 0x18, 0x5a, 0x08, 0xc3, 0x68, 0xb3, 0x16,
    0xe5, 0xc2, 0x4d, 0x73, 0xdb, 0xc0, 0x5e, 0xd5, 0x8a, 0xd7, 0x35, 0x57, 0x07, 0x50, 0xaa, 0x55,
    0x4d, 0x5b, 0x37, 0x2f, 0x30, 0xcf, 0xe8, 0x16, 0xb4, 0x50, 0x31, 0x5e, 0xbe, 0x3d, 0x3f, 0x3d,
    0xb6, 0x30, 0xa7, 0x14, 0x62, 0x2b, 0xe5, 0xe8, 0xb3, 0x1b, 0xe8, 0x24, 0x62, 0x0e, 0x68, 0xb1,
    0x17, 0x23, 0xc9, 0xf8, 0xea, 0x64, 0x99, 0x97, 0xf0, 0x4d, 0x26, 0x3d, 0x45, 0xd9, 0x61, 0xd2,
    0x5c, 0x89, 0xc3, 0x9d, 0x50, 0x32, 0xfa, 0x4c, 0x3d, 0xca, 0xc2, 0x2d, 0xf2, 0x88, 0xdd, 0xbe,
    0xdf, 0x94, 0x83, 0xa1, 0x15, 0xc5, 0x9e, 0x4c, 0x48, 0x51, 0x9e, 0xa5, 0xaa, 0xd8, 0x6a, 0x9a,
    0x66, 0x13, 0xa1, 0x14, 0x6a, 0xb2, 0x27, 0x38, 0x7a, 0x5a, 0xc0, 0x38, 0x08, 0xe4, 0x27, 0xc2,
    0x18, 0x85, 0x10, 0xab, 0xea, 0x32, 0x87, 0xb1, 0x0e, 0x27, 0xe3, 0x82, 0x9e, 0x10, 0xee, 0x61,
    0xcc, 0xae, 0x4f, 0xc6, 0xbb, 0x2b, 0x7d, 0xcd, 0xd0, 0x0d, 0x6c, 0x7d, 0xfe, 0xa3, 0x7c, 0x4e,
    0xa1, 0x54, 0x61, 0x63, 0x22, 0xfc, 0x21, 0xd9, 0x14, 0x97, 0xcb, 0x68, 0x7d, 0xaf, 0xed, 0xb6,
    0xbd, 0x62, 0xf4, 0xce, 0x00, 0xce, 0x63, 0x7f, 0xe1, 0x5d, 0x21, 0xbe, 0x23, 0x6f, 0x68, 0x6d,
    0xfe, 0x0d, 0xfb, 0xab, 0xb3, 0x63, 0x1f, 0x8c, 0x11, 0xa6, 0x4c, 0x6e, 0xf3, 0x61, 0x9f, 0x5e,
    0xed, 0xa3, 0x1d
};

static const zlib_struct compr_struct = { 565, 259, compr };

const zlib_struct *pdflua_zlib_struct_ptr = &compr_struct;
