@x
#include <kpathsea/kpathsea.h>
@y
#include <kpathsea/kpathsea.h>
#ifdef WIN32
char kanjioption[16];
#endif
@z

@x
@d TEX     "tex"
@d TROFF   "soelim | eqn -Tps -d$$ | troff -Tps"

@c
#ifndef MPXCOMMAND
#define MPXCOMMAND "makempx"
#endif
@y
@d TEX     "ptex"
@d TROFF   "gsoelim | geqn -Tps -d$$ | gtroff -Tps"

@c
#ifndef MPXCOMMAND
#ifdef WIN32
#define MPXCOMMAND "pmakempx"
#else
#define MPXCOMMAND "makempx"
#endif
#endif
@z

@x
    if (cnf_cmd!=NULL && (strcmp (cnf_cmd, "1")!=0)) {
      if (mp_troff_mode(mp)!=0)
        cmd = concatn (cnf_cmd, " -troff ",
                     qmpname, " ", qmpxname, NULL);
      else if (mpost_tex_program!=NULL && *mpost_tex_program != '\0')
        cmd = concatn (cnf_cmd, " -tex=", mpost_tex_program, " ",
                     qmpname, " ", qmpxname, NULL);
@y
    if (cnf_cmd!=NULL && (strcmp (cnf_cmd, "1")!=0)) {
      if (kanjioption[0])
        cnf_cmd = concatn (cnf_cmd, " --kanji=", kanjioption, NULL);
      if (mp_troff_mode(mp))
        cmd = concatn (cnf_cmd, " -troff ",
                       qmpname, " ", qmpxname, NULL);
      else if (mpost_tex_program!=NULL && *mpost_tex_program != '\0')
        cmd = concatn (cnf_cmd, " -tex=", mpost_tex_program, " ",
                       qmpname, " ", qmpxname, NULL);
@z

@x
      if (mpost_tex_program != NULL && *mpost_tex_program != '\0') {
        maincmd = mpost_xstrdup(mpost_tex_program);
      } else {
        if (mpxmode == mpx_tex_mode) {
          s = kpse_var_value("TEX");
          if (s==NULL) s = kpse_var_value("MPXMAINCMD");
          if (s==NULL) s = mpost_xstrdup (TEX);
          maincmd = (char *)mpost_xmalloc (strlen(s)+strlen(default_args)+1);
          strcpy(maincmd,s);
@y
      if (mpost_tex_program != NULL && *mpost_tex_program != '\0') {
#ifdef WIN32
        if (kanjioption[0]) {
          maincmd = (char *)mpost_xmalloc (strlen(mpost_tex_program) +
                                   strlen(kanjioption) + 15);
          strcpy(maincmd, mpost_tex_program);
          strcat(maincmd, " --kanji=");
          strcat(maincmd, kanjioption);
        } else
          maincmd = mpost_xstrdup(mpost_tex_program);
#else
        maincmd = mpost_xstrdup(mpost_tex_program);
#endif
      } else {
        if (mpxmode == mpx_tex_mode) {
          s = kpse_var_value("TEX");
          if (s==NULL) s = kpse_var_value("MPXMAINCMD");
          if (s==NULL) s = mpost_xstrdup (TEX);
#ifdef WIN32
          if (kanjioption[0])
            maincmd = (char *)mpost_xmalloc (strlen(s)+strlen(default_args)+
                                             strlen(kanjioption)+13);
          else
            maincmd = (char *)mpost_xmalloc (strlen(s)+strlen(default_args)+1);
#else
          maincmd = (char *)mpost_xmalloc (strlen(s)+strlen(default_args)+1);
#endif
          strcpy(maincmd,s);
#ifdef WIN32
          if (kanjioption[0]) {
            strcat(maincmd, " --kanji=");
            strcat(maincmd, kanjioption);
          }
#endif
@z

@x
        const char *banner = "% Written by metapost version ";
@y
        const char *banner = "% Written by pmpost version ";
@z

@x
  mpost_xfree (cnf_cmd);
@y
  if(cnf_cmd)
    mpost_xfree (cnf_cmd);
@z

@x
      const char *banner = "% Written by dvitomp version ";
@y
      const char *banner = "% Written by pdvitomp version ";
@z

@x
      { "kpathsea-debug",            1, 0, 0 },
@y
      { "kpathsea-debug",            1, 0, 0 },
      { "kanji",                     1, 0, 0 },
@z

@x
        if (user_progname == NULL) 
	      user_progname = optarg;
      }
@y
        if (user_progname == NULL) 
	      user_progname = optarg;
      }
#ifdef WIN32
    } else if (ARGUMENT_IS ("kanji")) {
      strcpy(kanjioption, optarg);
      if(!set_enc_string(optarg, optarg)) {
        fprintf(stderr,"Ignoring unknown argument `%s' to --kanji", optarg);
      }
#endif
@z

@x
      { "no-kpathsea",               0, &nokpse, 1 },
@y
      { "no-kpathsea",               0, &nokpse, 1 },
      { "kanji",                     1, 0, 0 },
@z

@x
    } else if (option_is ("progname")) {
      user_progname = optarg;
@y
    } else if (option_is ("progname")) {
      user_progname = optarg;
#ifdef WIN32
    } else if (option_is ("kanji")) {
      strcpy (kanjioption, optarg);
      if(!set_enc_string(optarg, optarg)) {
        fprintf(stderr,"Ignoring unknown argument `%s' to --kanji", optarg);
      }
#endif
@z

@x
  fprintf(stdout, "This is dvitomp %s" WEB2CVERSION "\n", s);
else
  fprintf(stdout, "This is MetaPost %s" WEB2CVERSION "\n", s);
mpost_xfree(s);
fprintf(stdout,
"\n"
"Usage: mpost [OPTION] [&MEMNAME] [MPNAME[.mp]] [COMMANDS]\n"
"       mpost --dvitomp DVINAME[.dvi] [MPXNAME[.mpx]]\n"
"\n"
"  Run MetaPost on MPNAME, usually creating MPNAME.NNN (and perhaps\n"
"  MPNAME.tfm), where NNN are the character numbers generated.\n"
"  Any remaining COMMANDS are processed as MetaPost input,\n"
"  after MPNAME is read.\n\n"
"  With a --dvitomp argument, MetaPost acts as DVI-to-MPX converter only.\n"
"  Call MetaPost with --dvitomp --help for option explanations.\n\n");
fprintf(stdout,
"  -ini                      be inimpost, for dumping mem files\n"
"  -interaction=STRING       set interaction mode (STRING=batchmode/nonstopmode/\n"
"                            scrollmode/errorstopmode)\n"
"  -numbersystem=STRING      set number system mode (STRING=scaled/double/binary/decimal)\n"
"  -jobname=STRING           set the job name to STRING\n"
@y
  fprintf(stdout, "This is pdvitomp %s" WEB2CVERSION "\n", s);
else
  fprintf(stdout, "This is pMetaPost %s" WEB2CVERSION "\n", s);
mpost_xfree(s);
fprintf(stdout,
"\n"
"Usage: pmpost [OPTION] [&MEMNAME] [MPNAME[.mp]] [COMMANDS]\n"
"       pmpost --dvitomp DVINAME[.dvi] [MPXNAME[.mpx]]\n"
"\n"
"  Run pMetaPost on MPNAME, usually creating MPNAME.NNN (and perhaps\n"
"  MPNAME.tfm), where NNN are the character numbers generated.\n"
"  Any remaining COMMANDS are processed as pMetaPost input,\n"
"  after MPNAME is read.\n\n"
"  With a --dvitomp argument, pMetaPost acts as DVI-to-MPX converter only.\n"
"  Call pMetaPost with --dvitomp --help for option explanations.\n\n");
fprintf(stdout,
"  -ini                      be inipmpost, for dumping mem files\n"
"  -interaction=STRING       set interaction mode (STRING=batchmode/nonstopmode/\n"
"                            scrollmode/errorstopmode)\n"
"  -numbersystem=STRING      set number system mode (STRING=scaled/double/binary/decimal)\n"
"  -jobname=STRING           set the job name to STRING\n"
"  -kanji=STRING             set the Japanese encoding to STRING\n"
@z

@x
"  -version                  output version information and exit\n"
"\n"
"Email bug reports to mp-implementors@@tug.org.\n"
@y
"  -version                  output version information and exit\n"
@z

@x
  fprintf(stdout, "This is dvitomp %s" WEB2CVERSION "\n", s);
else
  fprintf(stdout, "This is MetaPost %s" WEB2CVERSION "\n", s);
mpost_xfree(s);
fprintf(stdout,
"\n"
"Usage: dvitomp DVINAME[.dvi] [MPXNAME[.mpx]]\n"
"       mpost --dvitomp DVINAME[.dvi] [MPXNAME[.mpx]]\n"
"\n"
"  Convert a TeX DVI file to a MetaPost MPX file.\n\n");
fprintf(stdout,
"  -progname=STRING          set program name to STRING\n"
@y
  fprintf(stdout, "This is pdvitomp %s" WEB2CVERSION "\n", s);
else
  fprintf(stdout, "This is pMetaPost %s" WEB2CVERSION "\n", s);
mpost_xfree(s);
fprintf(stdout,
"\n"
"Usage: pdvitomp DVINAME[.dvi] [MPXNAME[.mpx]]\n"
"       pmpost --dvitomp DVINAME[.dvi] [MPXNAME[.mpx]]\n"
"\n"
"  Convert a TeX DVI file to a MetaPost MPX file.\n\n");
fprintf(stdout,
"  -progname=STRING          set program name to STRING\n"
"  -kanji=STRING             set kanji encoding (sjis, jis, euc, utf8)\n"
@z

@x
  fprintf(stdout, "dvitomp (MetaPost) %s" WEB2CVERSION "\n", s);
else
  fprintf(stdout, "MetaPost %s" WEB2CVERSION "\n", s);
@y
  fprintf(stdout, "pdvitomp (pMetaPost) %s" WEB2CVERSION "\n", s);
else
  fprintf(stdout, "pMetaPost %s" WEB2CVERSION "\n", s);
@z

@x
"Author of the CWEB MetaPost: Taco Hoekwater.\n"
@y
"Author of the CWEB MetaPost: Taco Hoekwater.\n"
"Authors of pMetaPost: Michio Matsuyama, Hideyuki Suzuki.\n"
@z

@x
  const char * banner = "This is MetaPost, version ";
@y
  const char * banner = "This is pMetaPost, version ";
@z

@x
  options->print_found_names = (int)true;
  {
    const char *base = xbasename(argv[0]);
    if (!strcmp(base, "dvitomp") || !strcasecmp(base, "dvitomp.exe"))
      dvitomp_only=1;
  }
  if (dvitomp_only) {
    @<Read and set dvitomp command line options@>;
  } else {
@y
  options->print_found_names = (int)true;

#if defined(WIN32)
  {
    char *p , *q;
    p = (char *)xbasename(argv[0]);
    if ((q = strrchr(p, '.')) && !stricmp(q, ".exe"))
       *q = '\0';
    argv[0] = p;
   }
  kanjioption[0] = '\0';
  enable_UPTEX (false);
  set_enc_string("sjis", "sjis");
#endif

  if (strstr(argv[0], "dvitomp") != NULL) {
    dvitomp_only=1;
    @<Read and set dvitomp command line options@>;
  } else {
#ifdef WIN32
    options->mem_name = mpost_xstrdup(argv[0]);
#endif
@z

@x
  if(putenv(xstrdup("engine=metapost")))
@y
  if(putenv(xstrdup("engine=pmpost")))
@z
